import type { Flashcards } from "./background/database";

declare global {
	interface Translation {
		src: string;
		result: string;
		languages: LanguagePair;
	}

	interface Flashcard {
		id: IDBValidKey;
		src: string;
		result: string;
		dateAdded: Date;
		exported: boolean;
		languages: LanguagePair;
	}

	interface LanguagePair {
		srcLang: Language;
		dstLang: Language;
	}

	interface Language {
		code: string;
		name: string;
	}

	interface Window {
		hasRun?: boolean;
		flashcardDB: Flashcards;
	}
}
